# ARTY pinout
#
# raw_clk_p 100 MHz single ended crystal clock
set_property PACKAGE_PIN E3 [get_ports raw_clk_p]
set_property IOSTANDARD LVCMOS33 [get_ports raw_clk_p]
#
# rstn pushbutton, active low
set_property PACKAGE_PIN C2 [get_ports rstn]
set_property IOSTANDARD LVCMOS33 [get_ports rstn]
#
################# PMOD JA #########################
#
# PMOD JA pin 4, int
set_property PACKAGE_PIN D12 [get_ports int]
set_property IOSTANDARD LVCMOS33 [get_ports int]
set_property PULLUP true [get_ports int]
#
# PMOD JA pin 3, SDA
set_property PACKAGE_PIN A11 [get_ports SDA]
set_property IOSTANDARD LVCMOS33 [get_ports SDA]
set_property PULLUP true [get_ports SDA]
#
# PMOD JA pin 2, SCL
set_property PACKAGE_PIN B11 [get_ports SCL]
set_property IOSTANDARD LVCMOS33 [get_ports SCL]
set_property PULLUP true [get_ports SCL]
#
####################################################
#
#
# I2C_RST BTN0
set_property PACKAGE_PIN D9 [get_ports I2C_RST]
set_property IOSTANDARD LVCMOS33 [get_ports I2C_RST]
#
# INIT BTN1
set_property PACKAGE_PIN C9 [get_ports INIT]
set_property IOSTANDARD LVCMOS33 [get_ports INIT]
#
# WR BTN2
set_property PACKAGE_PIN B9 [get_ports WR]
set_property IOSTANDARD LVCMOS33 [get_ports WR]
#
# RD BTN3
set_property PACKAGE_PIN B8 [get_ports RD]
set_property IOSTANDARD LVCMOS33 [get_ports RD]
#
#
#######################################################
#
# SELECT_1145 SW0
set_property PACKAGE_PIN A8 [get_ports SELECT_1145]
set_property IOSTANDARD LVCMOS33 [get_ports SELECT_1145]
#
#######################################################
#
# locked LD4 RED2
set_property PACKAGE_PIN J3 [get_ports locked]
set_property IOSTANDARD LVCMOS33 [get_ports locked]
#
# clk_slow_test LD5 (J5)
set_property PACKAGE_PIN J5 [get_ports clk_slow_test]
set_property IOSTANDARD LVCMOS33 [get_ports clk_slow_test]
#
# data_out_led BLUE0
set_property PACKAGE_PIN E1 [get_ports data_out_led]
set_property IOSTANDARD LVCMOS33 [get_ports data_out_led]
#
# ack_or_complete RED1
set_property PACKAGE_PIN G3 [get_ports ack_or_complete]
set_property IOSTANDARD LVCMOS33 [get_ports ack_or_complete]
#
#
#############################################################
# Timing constraints
#############################################################
#
#
# Create a 100 MHz clock period constraint for the clk input
create_clock -period 10.000 -name clk -waveform {0.000 5.000} [get_ports raw_clk_p]
#
set_false_path -to [get_ports locked]
set_false_path -to [get_ports clk_slow_test]
set_false_path -to [get_ports data_out_led]
set_false_path -to [get_ports ack_or_complete]
#
set_false_path -from [get_ports rstn]
set_false_path -from [get_ports I2C_RST]
set_false_path -from [get_ports INIT]
set_false_path -from [get_ports WR]
set_false_path -from [get_ports RD]
set_false_path -from [get_ports SELECT_1145]
#
set_false_path -from [get_ports SDA]
set_false_path -from [get_ports SCL]
set_false_path -to [get_ports SDA]
set_false_path -to [get_ports SCL]
#
set_clock_groups -name clk_false -asynchronous -group [get_clocks clk] -group [get_clocks [get_clocks -of_objects [get_pins clk_box/MMCME2_BASE_inst/CLKOUT1]]]
#
#set_output_delay -clock raw_clk_p -max 5.000 [get_ports SDA]
#set_input_delay -clock raw_clk_p -max 5.000 [get_ports SDA]
#
#
#   Compress bitstream
#
set_property BITSTREAM.GENERAL.COMPRESS TRUE [current_design]
#
#   Set configuration bank voltage select for ARTY board
#
set_property CFGBVS VCCO [current_design]
#




